var mainCanvas;
var mainCntx;
var canvas;
var cntx;

function init(){
	canvas=document.getElementById("visualisation");
    cntx=canvas.getContext("2d");
    auxCanvas=document.getElementById("backBuffer");
    auxCntx=auxCanvas.getContext("2d");
    
    showAppTitle();
    initialValues();
    initialiseGUI();
    initialiseEvents();
    drawBasicScreen();
}
      
function initialiseEvents(){
	$("#visualisation").on("mousemove touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseMove();
    });

    $("#visualisation").on("mouseup touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseUp();
    });

    $("#visualisation").on("mousedown touchend",function(evt){
        var rect=canvas.getBoundingClientRect();
        mx=evt.clientX-rect.left;
        my=evt.clientY-rect.top;
        handleMouseDown();
    });

    window.addEventListener("beforeunload",function(e){
        clearInterval(timerLoop);
    });
}

function initialiseGUI(){
    //chkDirection=new chkbox(cntx,chkDirectionLEFT,chkDirectionTOP,"Αντιστροφή κατεύθυνσης",false);
    
    HscrNoOfCircles=new slider(HscrNoOfCirclesLEFT,HscrNoOfCirclesTOP,HscrNoOfCirclesWIDTH,HscrNoOfCirclesHEIGHT,HscrNoOfCirclesMin,HscrNoOfCirclesMax,HscrNoOfCirclesMin,HscrNoOfCirclesVisible,HscrNoOfCirclesScaleDigital,[],HscrNoOfCirclesViewComparative,cntx,false,valuePosFixed);
    HscrResolution=new slider(HscrResolutionLEFT,HscrResolutionTOP,HscrResolutionWIDTH,HscrResolutionHEIGHT,HscrResolutionMin,HscrResolutionMax,HscrResolutionMin,HscrResolutionVisible,HscrResolutionScaleDigital,[],HscrResolutionViewComparative,cntx,false,valuePosFixed);
    HScrDrawSpeed=new slider(HScrDrawSpeedLEFT,HScrDrawSpeedTOP,HScrDrawSpeedWIDTH,HScrDrawSpeedHEIGHT,HScrDrawSpeedMin,HScrDrawSpeedMax,HScrDrawSpeedMin,HScrDrawSpeedVisible,HScrDrawSpeedScaleDigital,[],HScrDrawSpeedViewComparative,cntx,false,valuePosFixed);
}

function initialValues(){
    TitleTOP=20;
    TitleWIDTH=550;
    TitleLEFT=(width-TitleWIDTH)/2;
    TitleHEIGHT=35;
    imgLogo=document.getElementById("Logo");
    width=canvas.width;
    height=canvas.height;

    BottomPanelTop=height-BottomPanelHeight;
    logoLeft=width-logoWidth-5;
    logoTop=BottomPanelTop+(BottomPanelHeight-logoHeight)/2;
    imgNxtStepEnabled=document.getElementById("ButtonEnabledSmall");
    imgNxtStepSelected=document.getElementById("ButtonSelSmall");
    imgBackStepEnabled=document.getElementById("BackEnabledSmall");
    imgBackStepSelected=document.getElementById("BackSelSmall");
    nxtStepLeft=width-nxtStepWidth-15-logoWidth;
    nxtStepTop=BottomPanelTop+20;
    BackStepLeft=2;
    BackStepTop=nxtStepTop;
    $("#ColorSchemes").val("palette");
    $("#algorithmSlctr").val("cardioid");
    initialisePalette();
}

function drawBasicScreen(){
    cntx.clearRect(0,0,canvas.width,canvas.height);
    //Εικόνες
    drawIntroImage();
    drawLogoImage();
    //Κουμπιά
    if(introStep<6){
    	$("#editTools").hide();
    	$("#divAlgorithmSelector").hide();
    	$("#divColorSchemes").hide();
    	drawButtonNext();
    }
    else{
    	$("#editTools").show();
        $("#divAlgorithmSelector").show();
    	$("#divColorSchemes").show();
    }
    if(introStep>1){
    	drawButtonBack();
    }
	var promptYCoord=BottomPanelTop+25;
    if(introStep==6){
    	HscrNoOfCircles.render();
        HscrResolution.render();
        HScrDrawSpeed.render();
		if(SelectedColorScheme==1){
			drawPalette();
		}

        /*if(introStep>5){
            cntx.strokeStyle="rgb(0,0,255)";
            cnvsWrite("",fontSize,"Arial",HScrParam1LEFT+HScrParam1WIDTH+15,HScrParam1TOP+13,"Επαναλήψεις");
            cnvsWrite("",fontSize,"Arial",HScrParam1LEFT+HScrParam1WIDTH+15,HScrParam2TOP+13,"Αρχικές Τιμές");
        }*/
        cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord,"Διάλεξε ένα σχήμα από τη λίστα και τροποποίησε τις παραμέτρους του Αλγόριθμου.");
        cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord+20,"για να δεις διαφορετικά αποτελέσματα. Ειδικά στο τελευταίο σχήμα θα διαπιστώσεις ότι ");
        cnvsWrite("rgb(0,0,255)",fontSize,"Arial",50,promptYCoord+40,"η υπομονή ανταμοίβεται!");
        /*if(SelectedAlgorithm>0){
            if(SelectedAlgorithm>1) {
                if(SelectedAlgorithm==4 && PolygonSides==3) {
                    cntx.strokeStyle="rgb(180,180,180)";
                }
                else {
                    cntx.strokeStyle="rgb(0,0,255)";
                }
            }
            DrawSelectedAlgorithm();
        }*/
    }
    /*if(!Drawing){
        var canvasData=cntx.getImageData(0,0,width,height);
        cntx.putImageData(canvasData,0,0);
    }*/
    if(introStep==6)copyImage();
}

function drawIntroImage(){
	Intro=document.getElementById("img"+introStep);
    var picTop=(height-Intro.height)/2;
    cntx.strokeStyle="black";
    //πλαίσιο καμβά
    cntx.rect(0,0,width,height);
    //άνω πλαίσιο
    cntx.rect(0,0,width,picTop-1);
    //κάτω πλαίσιο
    var lowRectTop=picTop+Intro.height+1;
    cntx.rect(0,lowRectTop,width,height-lowRectTop);

    cntx.stroke();
    cnvsWrite(LetterColor,35,"Arial",-1,TitleTOP+TitleHEIGHT,appTitle);
    cntx.drawImage(Intro,1,picTop);
    //auxCntx.drawImage(Intro,1,picTop);
}

function drawLogoImage(){
    var picTop=(height-Intro.height)/2;
    var lowRectTop=picTop+Intro.height+1;
    var logoTop=lowRectTop+((height-lowRectTop)-imgLogo.height)/2;
    cntx.drawImage(imgLogo,width-imgLogo.width-2,logoTop);
}

function showHTML(){
    window.open("index_DS_I_DS_II.html","_blank");
}

function drawButtonNext(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonNextHover()){
        cntx.drawImage(imgNxtStepSelected,nxtStepLeft,nxtStepTop);
    }
    else{
        cntx.drawImage(imgNxtStepEnabled,nxtStepLeft,nxtStepTop);
    }
}

function buttonNextHover(){
    if (mx>=nxtStepLeft && mx<=nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<=nxtStepTop+nxtStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function drawButtonBack(){
    //Διαχείριση κουμπιού [Επόμενο Βήμα]
    if (buttonBackHover()){
        cntx.drawImage(imgBackStepSelected,BackStepLeft,BackStepTop);
    }
    else{
        cntx.drawImage(imgBackStepEnabled,BackStepLeft,BackStepTop);
    }
}

function buttonBackHover(){
    if (mx>=BackStepLeft && mx<=BackStepLeft+BackStepWidth && my>=BackStepTop && my<=BackStepTop+BackStepHeight){
        return true;
    }
    else {
        return false;
    }
}

function cnvsWrite(clr,fontSize,fontName,txtX,txtY,txt){       
    if(fontName!=""){
    	cntx.font=fontSize+"px "+fontName;
    }
    if(clr!=""){
    	cntx.fillStyle=clr;
    }
    if(txtX<0) txtX=(canvas.width-cntx.measureText(txt).width)/2;
    cntx.fillText(txt,txtX,txtY);
}

function handleMouseDown(){
	if(introStep==6){
	    if(HScrDrawSpeed.markerHover(mx,my)){
	    	HScrDrawSpeed.markerGrabbed=true;
	    	HScrDrawSpeed.mouseXOffset=mx-HScrDrawSpeed.markerLeft;
	    }
	    else if(HscrNoOfCircles.markerHover(mx,my)){
	    	HscrNoOfCircles.markerGrabbed=true;
	    	HscrNoOfCircles.mouseXOffset=mx-HscrNoOfCircles.markerLeft;
	    }
	    else if(HscrResolution.markerHover(mx,my)){
	    	HscrResolution.markerGrabbed=true;
	    	HscrResolution.mouseXOffset=mx-HscrResolution.markerLeft;
	    }
	}
}

function handleMouseMove(){
    if(mx>=logoLeft && mx<logoLeft+logoWidth && my>=logoTop && my<logoTop+logoHeight){
        imgLogo=document.getElementById("LogoSel");
    }
    else{
        imgLogo=document.getElementById("Logo");
    }
    
    canvas.style.cursor="default";
    if(introStep==6){
        if(HScrDrawSpeed.markerGrabbed){
        	HScrDrawSpeed.setMarkerPosition(mx-HScrDrawSpeed.mouseXOffset);
            canvas.style.cursor="pointer";
            adjustmentValueChanged(HScrDrawSpeedIndx);
        }
        else if(HscrNoOfCircles.markerGrabbed){
        	HscrNoOfCircles.setMarkerPosition(mx-HscrNoOfCircles.mouseXOffset);
            canvas.style.cursor="pointer";
            adjustmentValueChanged(HscrNoOfCirclesIndx);
        }
        else if(HscrResolution.markerGrabbed){
        	HscrResolution.setMarkerPosition(mx-HscrResolution.mouseXOffset);
            canvas.style.cursor="pointer";
            adjustmentValueChanged(HscrResolutionIndx);
        }
        else if(HScrDrawSpeed.markerHover(mx,my) || HscrNoOfCircles.markerHover(mx,my) || HscrResolution.markerHover(mx,my)){
            canvas.style.cursor="pointer";
        }
        else if(SelectedColorScheme==1 && PaletteHover()){
        	canvas.style.cursor="pointer";
        }
    }

    drawBasicScreen();
    //console.log("mx="+mx+" , my="+my);
}

function handleMouseUp(){
    if (mx>=logoLeft && mx<logoLeft+logoWidth && my >=logoTop && my<logoTop+logoHeight) {
        showHTML();
    }
    if (mx>=nxtStepLeft && mx<nxtStepLeft+nxtStepWidth && my>=nxtStepTop && my<nxtStepTop+nxtStepHeight && introStep<6) {
        introStep++;
        if(introStep==6){
        	drawAuxiliaryBackground();
        	resetDrawingLoop();
        }
    }
    if (mx>=BackStepLeft && mx<BackStepLeft+BackStepWidth && my>=BackStepTop && my<BackStepTop+BackStepHeight && introStep>1) {
        introStep--;
        Drawing=false;
        clearInterval(timerLoop);
    }
    
    if(introStep==6){
    	HScrDrawSpeed.markerGrabbed=false;
    	HscrNoOfCircles.markerGrabbed=false;
    	HscrResolution.markerGrabbed=false;
		if(SelectedColorScheme==1 && PaletteHover()){
			SelectPaletteColor();
		}
    }
    drawBasicScreen();
}

function selectAlgorithm(){
    SelectedAlgorithm=$("#algorithmSlctr").prop("selectedIndex");
    SimulationStep=-1;
    drawBasicScreen();
}

function DrawSelectedAlgorithm(){
    if(SelectedAlgorithm==1){
        DrawCardioid();
    }
    else if(SelectedAlgorithm==2){
        DrawSecondAlgorithm();
    }
    else if(SelectedAlgorithm==3){
        DrawThirdAlgorithm();
    }
    else if(SelectedAlgorithm==4){
        DrawPolygon();
    }
}

function adjustmentValueChanged(indx){
    if(indx==HScrDrawSpeedIndx){
        resetDrawingLoop();
    }
    else if(indx==HscrNoOfCirclesIndx){
		NoOfCircles=HscrNoOfCircles.markerValue;
        drawAuxiliaryBackground();
        t=0;
	}
	else if(indx==HscrResolutionIndx){
		var Denominator=1;
		switch(HscrResolution.markerValue){
		case 0:
			Denominator=1;
			break;
		case 1:
			Denominator=2;
			break;
		case 2:
			enominator=4;
			break;
		case 3:
			Denominator=6;
			break;
		case 4:
			Denominator=20;
			break;
		case 5:
			Denominator=40;
			break;
		case 6:
			Denominator=80;
			break;
		case 7:
			Denominator=100;
			break;
		case 8:
			Denominator=1000;
			break;
		default:
			Denominator=10000;
			break;
		}
		AngleStep=Math.PI/Denominator;
        drawAuxiliaryBackground();
        t=0;
	}
	PreviousNoOfCircles=0;
	CurrentNoOfCircles=0;
	Drawing=true;

	drawBasicScreen();
}

function initialisePalette(){
	PaletteR[0]=0; PaletteG[0]=0; PaletteB[0]=0;
	PaletteR[1]=90; PaletteG[1]=90; PaletteB[1]=90;
	PaletteR[2]=255; PaletteG[2]=0; PaletteB[2]=0;
	PaletteR[3]=0; PaletteG[3]=255; PaletteB[3]=0;
	PaletteR[4]=0; PaletteG[4]=0; PaletteB[4]=255;
	PaletteR[5]=130; PaletteG[5]=0; PaletteB[5]=100;
	PaletteR[6]=240; PaletteG[6]=140; PaletteB[6]=70;
	PaletteR[7]=240; PaletteG[7]=80; PaletteB[7]=70;
	PaletteR[8]=160; PaletteG[8]=45; PaletteB[8]=170;
	PaletteR[9]=160; PaletteG[9]=45; PaletteB[9]=225;
	PaletteR[10]=100; PaletteG[10]=60; PaletteB[10]=200;
	PaletteR[11]=60; PaletteG[11]=130; PaletteB[11]=200;
	PaletteR[12]=60; PaletteG[12]=175; PaletteB[12]=200;
	PaletteR[13]=160; PaletteG[13]=175; PaletteB[13]=220;
	PaletteR[14]=210; PaletteG[14]=180; PaletteB[14]=150;
	PaletteR[15]=255; PaletteG[15]=255; PaletteB[15]=0;
}

function drawPalette(){
	for(var i=0;i<NoOfPaletteColors;i++){
		cntx.fillStyle="rgb("+PaletteR[i]+","+PaletteG[i]+","+PaletteB[i]+")";
		cntx.beginPath();
		cntx.fillRect(PaletteLeft+PaletteSlotSize*i,PaletteTop,PaletteSlotSize,PaletteSlotSize);
		cntx.fill();
	}
	cntx.strokeStyle="rgb(255,255,255)";
	var X1=PaletteLeft+PaletteSlotSize*SelectedColorIndex;
	var Y1=PaletteTop;
	var X2=X1+PaletteSlotSize;
	var Y2=Y1+PaletteSlotSize;
	cntx.beginPath();
	cntx.moveTo(X1,Y1);
	cntx.lineTo(X2,Y2);
	cntx.moveTo(X1,Y2);
	cntx.lineTo(X2,Y1);
	cntx.stroke();
}

function PaletteHover(){
    return (mx>=PaletteLeft && mx<PaletteLeft+NoOfPaletteColors*PaletteSlotSize && my>=PaletteTop && my<=PaletteTop+PaletteSlotSize);
}

function SelectPaletteColor(){
	SelectedColorIndex=parseInt((mx-PaletteLeft)/PaletteSlotSize);
	drawAuxiliaryBackground();
	drawBasicScreen();
	t=0;
	Drawing=true;
}

function itemStateChanged(slctr){
	if(slctr==colorSchemesIndx){
		SelectedColorScheme=$("#ColorSchemes").prop("selectedIndex")+1;
		drawAuxiliaryBackground();
		drawBasicScreen();
		t=0;
		Drawing=true;
	}
	else if(slctr==shapeLibIndx){
		CircleMultiplier=2;
		SelectedShape=$("#algorithmSlctr").prop("selectedIndex")+1;
		switch(SelectedShape){
		case 1:
			CircleMultiplier=.2;
			drawPolarGraph(polarCardioid);
			break;
		case 2:
			CircleMultiplier=.2;
			drawPolarGraph(polarLemniscate);
			break;
		case 3:
			drawPolarGraph(polarRose);
			break;
		case 4:
			drawPolarGraph(polarSpiral);
			break;
		case 5:
			CircleMultiplier=20;
		    t=0;
			break;
		case 6:
			drawPseudo3D();
			break;
		case 7:
			drawLissajous();
			break;
		}
		drawBasicScreen();
		drawAuxiliaryBackground();
		Drawing=true;
	}
}

function drawAuxiliaryBackground(){
	var backg=document.getElementById("img"+introStep);
	var picTop=(height-backg.height)/2;
	auxCntx.drawImage(backg,1,picTop);
}

function drawPattern(){
	if(Drawing){
		cntx.strokeStyle="rgb(0,0,0)";
		switch(SelectedShape){
		case 1:
		case 2:
		case 3:
		case 4:
			drawPolarPart(SelectedShape);
			break;
		case 5:
			drawMadness();
			break;
		case 6:
			drawPseudo3DPart();
			break;
		case 7:
			drawLissajousPart();
			break;
		}
		copyImage();
	}
}

function copyImage(){
    var canvasData=auxCntx.getImageData(1,102,width-2,371);
    cntx.putImageData(canvasData,1,102);
}

function resetDrawingLoop(){
    clearInterval(timerLoop);
    var newSpeed=(1+HScrDrawSpeed.max-HScrDrawSpeed.markerValue)*simSpeed;
    timerLoop=setInterval(function(){drawPattern();},newSpeed);
}